#include "stdafx.h"
#include "IS.h" //Industry standard
#include "SBG.h" //SBG (Pareto multilabel Dijkstra)
#include "SBGSL.h" // Single-label version

#include <boost/property_tree/ptree.hpp>
#include <boost/heap/binomial_heap.hpp>
#include <boost/foreach.hpp>
#include <map>
#include <vector>
#include <string>
#include <set>
#include <array>
#include <algorithm>
#include <cstdio>
#include <ctime>
#include <limits>

#include <exception>
#include <iostream>

#include "NetworkData.h"
#include "Label.h"
#include "SearchPQ.h"
#include "HelperFunctions.h"

namespace pt = boost::property_tree;

#include <random>

int _tmain(int argc, char** argv)
{
	int numstart = stoi(argv[1]);
	int numend = stoi(argv[2]);

	std::string europe = "NETWORK_FOLDER";
	NetworkData network(europe, true);
	
	ifstream file;
	file.open("test-instances.txt");

	if(file.is_open()){
		int number ;
		int start ;
		int destination ;
		int start_time ;
		int shift_time;
		while(file.good()){
			file >> number;
			file >> start;
			file >> destination;
			file >> start_time;
			file >> shift_time;

			if(number >= numstart && number < numend) {
				std::cout << number << ",";
				SBG mf(number, network, start, destination, start_time, shift_time);
				mf.search("Results/oneday-SBG.txt", false);
				SBGSL sf(number, network, start, destination, start_time, shift_time);
				sf.search("Results/oneday-SBGSL.txt", false);
				IS sl(number, network, start, destination, start_time, shift_time);
				sl.search("Results/oneday-IS.txt", false);
				SBG mf2(number, network, start, destination, start_time, shift_time);
				mf2.search("Results/twoday-SBG.txt", true);
				SBGSL sf2(number, network, start, destination, start_time, shift_time);
				sf2.search("Results/twoday-SBGSL.txt", true);
				IS sl2(number, network, start, destination, start_time, shift_time);
				sl2.search("Results/twoday-IS.txt", true);
			} 
		}
	}
}

