#include <vector>
#include <cstdio>
#include "Label.h"
#include <tuple>

using namespace std;

vector<int> getPath(Label& labelNew, vector< Label >& labels) {
	vector<int> path;
	int prec = labelNew.id;
	while(prec != -1){
		path.push_back(labels[prec].node);
		prec = labels[prec].prec_id;
	}
	return path;
}


void writePath(Label& labelNew, vector< Label >& labels, std::string file) {
	std::ofstream f;
	f.open(file, std::ofstream::out | std::ofstream::app);
	int prec = labelNew.id;
	while(prec != -1){
		f << labels[prec].node <<"," ;
		prec = labels[prec].prec_id;
	}
	f << std::endl;
	f.close();
}


void writePath(int index, vector<int> path, ofstream & res){
	res << "int path" <<index<<"[] = {";
	for(int i = 0; i!= path.size()-1; i++){
		res << path[i] << ",";
	}
	res << path[path.size()-1] << "};" << endl;
	res << "g2.setColor(colors["<<index%5+2<<"]); paintPath(g2,path"<<index<<");" << endl;
}

void printPath(vector<int> path){
	cout << endl;
	for(int i = 0; i!= path.size()-1; i++){
		cout << path[i] << ",";
	}
	cout << endl;
}

void saveAndOrderPath(vector<int> & path, int index, int arrivaltime, vector < tuple <int, int, vector<int> > > & orderedPathSet){
	orderedPathSet.push_back( std::make_tuple(index, arrivaltime, path) );
}

int normalizedTime(int time){
	if(time >= 604800)
		return time-604800;
	if(time < 0)
		return time + 604800;
	return time;
}

int timeDriven(int arrivaltime, int departuretime){
	if(arrivaltime<=departuretime){
		return arrivaltime+604800-departuretime;
	}else{
		return arrivaltime - departuretime;
	}
}