#ifndef RITCH_UTIL_COMPOUND_CONTAINER_H_
#define RITCH_UTIL_COMPOUND_CONTAINER_H_

namespace ritch
{
namespace util
{
	
template <typename T1, typename Container1, typename T2, typename Container2>
class CompundContainerAdaptor
{
private:
	Container1<T1>* _container_1;
	Container2<T2>* _container_2;

public:
	friend void swap(std::tuple<T1&,T2&> lhs, std::tuple<T1&,T2&> rhs)
	{
		swap(std::get<0>(lhs), std::get<0>(rhs));
		swap(std::get<1>(lhs), std::get<1>(rhs));
	}

	std::tuple<T1&,T2&> operator[] (size_t index)
	{
		return (*_container_1)[index]
	}
};

}
}

#endif
