#ifndef RITCH_UTIL_TIMING_H_
#define RITCH_UTIL_TIMING_H_

#include <cassert>
#include <chrono>

namespace ritch
{
namespace util
{


typedef std::chrono::high_resolution_clock::time_point TimePoint;

inline TimePoint time_stamp()
{
	return std::chrono::high_resolution_clock::now();
}

inline double get_duration_in_seconds(const TimePoint& from, const TimePoint& to)
{
	assert(from <= to);
	return std::chrono::duration_cast<std::chrono::duration<double>>(to - from).count();
}


}
}

#endif // RITCH_UTIL_TIMING_H_
